// Load dts shapes and merge animations
datablock TSShapeConstructor(AlienQueenDts)
{
    baseShape  = "./AlienQueen.dts";
    sequence0  = "./AQ_Root.dsq root";

    sequence1  = "./AQ_Walk.dsq run";
    sequence2  = "./AQ_Walk.dsq walk";
    sequence3  = "./AQ_Back.dsq back";
    sequence4  = "./AQ_Walk.dsq side";

    sequence5  = "./AQ_Root.dsq crouch";
    sequence6  = "./AQ_Walk.dsq crouchRun";
    sequence7  = "./AQ_Walk.dsq crouchBack";
    sequence8  = "./AQ_Walk.dsq crouchSide";

    sequence9  = "./AQ_Root.dsq look";
    sequence10 = "./AQ_Root.dsq headside";
    sequence11 = "./AQ_Root.dsq headUp";

    sequence12 = "./AQ_Jump.dsq jump";
    sequence13 = "./AQ_Jump.dsq standjump";
    sequence14 = "./AQ_Root.dsq fall";
    sequence15 = "./AQ_Land.dsq land";

    sequence16 = "./AQ_Tailswing.dsq armAttack";
    sequence17 = "./AQ_Root.dsq armReadyLeft";
    sequence18 = "./AQ_Root.dsq armReadyRight";
    sequence19 = "./AQ_Root.dsq armReadyBoth";
    sequence20 = "./AQ_Root.dsq spearready";  
    sequence21 = "./AQ_Root.dsq spearThrow";

    sequence22 = "./AQ_Root.dsq talk";  

    sequence23 = "./AQ_Death.dsq death1"; 
    
    sequence24 = "./AQ_Root.dsq shiftUp";
    sequence25 = "./AQ_Root.dsq shiftDown";
    sequence26 = "./AQ_Root.dsq shiftAway";
    sequence27 = "./AQ_Root.dsq shiftTo";
    sequence28 = "./AQ_Root.dsq shiftLeft";
    sequence29 = "./AQ_Root.dsq shiftRight";
    sequence30 = "./AQ_Root.dsq rotCW";
    sequence31 = "./AQ_Root.dsq rotCCW";

    sequence32 = "./AQ_Root.dsq undo";
    sequence33 = "./AQ_Root.dsq plant";

    sequence34 = "./AQ_eggsack.dsq sit";

    sequence35 = "./AQ_Root.dsq wrench";

   sequence36 = "./AQ_Claw.dsq activate";
   sequence37 = "./AQ_Root.dsq activate2";

   sequence38 = "./AQ_Root.dsq leftrecoil";
};

datablock AudioProfile(AlienQueenPainSound)
{
    fileName = "./AQpainsound.wav";
    description = AudioClose3d;
    preload = true;
};

datablock AudioProfile(AlienQueenJumpSound)
{
    fileName = "./AQ_idle_3.wav";
    description = AudioClose3d;
    preload = true;
};

datablock AudioProfile(AlienQueenIdleSound1)
{
   filename    = "./AQ_idle_1.wav";
   description = AudioClose3d;
   preload = true;
};

datablock AudioProfile(AlienQueenIdleSound2)
{
   filename    = "./AQ_idle_2.wav";
   description = AudioClose3d;
   preload = true;
};

datablock AudioProfile(AlienQueenIdleSound3)
{
   filename    = "./AQ_idle_3.wav";
   description = AudioClose3d;
   preload = true;
};


datablock AudioProfile(AlienQueenDeathSound)
{
    fileName = "./AQDeathsound.wav";
    description = AudioClose3d;
    preload = true;
};  

datablock DebrisData( AlienQueenDebris )
{
   explodeOnMaxBounce = false;

   elasticity = 0.15;
   friction = 0.5;

   lifetime = 4.0;
   lifetimeVariance = 0.0;

   minSpinSpeed = 40;
   maxSpinSpeed = 600;

   numBounces = 5;
   bounceVariance = 0;

   staticOnMaxBounce = true;
   gravModifier = 1.0;

   useRadiusMass = false;
   baseRadius = 1;

   velocity = 20.0;
   velocityVariance = 12.0;
};             

datablock PlayerData(AlienQueenArmor : PlayerStandardArmor)
{
     renderFirstPerson = false;
   emap = false;
   
   className = Armor;
   shapeFile = "./AlienQueen.dts";
   cameraMaxDist = 10;
   cameraTilt = 0;//0.174 * 2.5; //~25 degrees
   cameraVerticalOffset = 2;
   computeCRC = false;
  
   canObserve = true;
   cmdCategory = "Clients";

   cameraDefaultFov = 90.0;
   cameraMinFov = 5.0;
   cameraMaxFov = 120.0;
   
   //debrisShapeName = "~/data/shapes/player/debris_player.dts";
   //debris = horseDebris;

   aiAvoidThis = true;

   minLookAngle = -1.5708;
   maxLookAngle = 1.5708;
   maxFreelookAngle = 3.0;

   mass = 65;
   drag = 0.1;
   maxdrag = 0.52;
   density = 0.7;
   maxDamage = 600;
   maxEnergy =  10;
   repairRate = 0.33;
   energyPerDamagePoint = 75.0;

   rechargeRate = 0.4;

   runForce = 50 * 90;
   runEnergyDrain = 0;
   minRunEnergy = 0;
   maxForwardSpeed = 10;
   maxBackwardSpeed = 10;
   maxSideSpeed = 10;
   mindustspeed= 10;

   maxForwardCrouchSpeed = 10;
   maxBackwardCrouchSpeed = 10;
   maxSideCrouchSpeed = 10;

   maxForwardProneSpeed = 10;
   maxBackwardProneSpeed = 10;
   maxSideProneSpeed = 10;

   maxForwardWalkSpeed = 5;
   maxBackwardWalkSpeed = 5;
   maxSideWalkSpeed = 5;

   maxUnderwaterForwardSpeed = 20;
   maxUnderwaterBackwardSpeed = 7.8;
   maxUnderwaterSideSpeed = 7.8;

   jumpForce = 13 * 90; //8.3 * 90;
   jumpEnergyDrain = 0;
   minJumpEnergy = 0;
   jumpDelay = 0;

   minJetEnergy = 0;
    jetEnergyDrain = 0;
    canJet = 0;

   recoverDelay = 0;
   recoverRunForceScale = 1.2;

   minImpactSpeed = 250;
   speedDamageScale = 3.8;

   boundingBox            = vectorScale("3.0 4.0 7.0", 4); //"2.5 2.5 2.4";
   crouchBoundingBox    = vectorScale("0.9 1.8 1.7", 4); //"2.5 2.5 2.4";
   proneBoundingBox        = vectorScale("0.9 1.8 1.7", 4); //"2.5 2.5 2.4";

    useCustomPainEffects = true;
    PainSound            = AlienQueenPainSound;
    DeathSound            = AlienQueenDeathSound;

   pickupRadius = 0.75;
   
   // Damage location details
   boxNormalHeadPercentage       = 0.83;
   boxNormalTorsoPercentage      = 0.49;
   boxHeadLeftPercentage         = 0;
   boxHeadRightPercentage        = 1;
   boxHeadBackPercentage         = 0;
   boxHeadFrontPercentage        = 1;

   // Foot Prints
   //decalData   = HorseFootprint;
   //decalOffset = 0.25;
    
   jetEmitter = "";
   jetGroundEmitter = "";
   jetGroundDistance = 4;
  
   //footPuffEmitter = LightPuffEmitter;
   footPuffNumParts = 10;
   footPuffRadius = 0.25;

   //dustEmitter = LiftoffDustEmitter;

   splash = PlayerSplash;
   splashVelocity = 4.0;
   splashAngle = 67.0;
   splashFreqMod = 300.0;
   splashVelEpsilon = 0.60;
   bubbleEmitTime = 0.1;
   splashEmitter[0] = PlayerFoamDropletsEmitter;
   splashEmitter[1] = PlayerFoamEmitter;
   splashEmitter[2] = PlayerBubbleEmitter;
   mediumSplashSoundVelocity = 10.0;   
   hardSplashSoundVelocity = 20.0;   
   exitSplashSoundVelocity = 5.0;

   // Controls over slope of runnable/jumpable surfaces
   runSurfaceAngle  = 65;
   jumpSurfaceAngle = 66;

   minJumpSpeed = 20;
   maxJumpSpeed = 30;

   horizMaxSpeed = 68;
   horizResistSpeed = 33;
   horizResistFactor = 0.35;

   upMaxSpeed = 80;
   upResistSpeed = 25;
   upResistFactor = 0.3;
   
   footstepSplashHeight = 0.35;

   //NOTE:  some sounds commented out until wav's are available

   JumpSound            = AlienQueenJumpSound;

   // Footstep Sounds
//   FootSoftSound        = HorseFootFallSound;
//   FootHardSound        = HorseFootFallSound;
//   FootMetalSound       = HorseFootFallSound;
//   FootSnowSound        = HorseFootFallSound;
//   FootShallowSound     = HorseFootFallSound;
//   FootWadingSound      = HorseFootFallSound;
//   FootUnderwaterSound  = HorseFootFallSound;
   //FootBubblesSound     = FootLightBubblesSound;
   //movingBubblesSound   = ArmorMoveBubblesSound;
   //waterBreathSound     = WaterBreathMaleSound;

   //impactSoftSound      = ImpactLightSoftSound;
   //impactHardSound      = ImpactLightHardSound;
   //impactMetalSound     = ImpactLightMetalSound;
   //impactSnowSound      = ImpactLightSnowSound;
   
   impactWaterEasy      = Splash1Sound;
   impactWaterMedium    = Splash1Sound;
   impactWaterHard      = Splash1Sound;
   
   groundImpactMinSpeed    = 10.0;
   groundImpactShakeFreq   = "4.0 4.0 4.0";
   groundImpactShakeAmp    = "1.0 1.0 1.0";
   groundImpactShakeDuration = 0.8;
   groundImpactShakeFalloff = 10.0;
   
   //exitingWater         = ExitingWaterLightSound;
   
   observeParameters = "0.5 4.5 4.5";

   // Inventory Items
    maxItems   = 3;    //total number of bricks you can carry
    maxWeapons = 2;        //this will be controlled by mini-game code
    maxTools = 5;
    
    uiName = "Alien Queen";
    rideable = false;
        lookUpLimit = 0.6;
        lookDownLimit = 0.2;

   numMountPoints = 0;
   mountThread[0] = "sit";
   mountNode[0] = 0;

    canRide = false;
    showEnergyBar = false;
    paintable = true;
 
    brickImage = AlienQueenBrickImage;    //the imageData to use for brick deployment

};

function AlienQueenArmor::onAdd(%this,%obj)
{
    parent::onAdd(%this,%obj);
    schedule(20,0,QueenSoundCheck,%obj);
}

function QueenSoundCheck(%obj)
{
    if(!isObject(%obj))
        return;
    if(%obj.getDatablock() != AlienQueenArmor.getID())
        return;
    cancel(%obj.AlienQueenIdleLoop);
    %obj.playAudio(0,"AlienQueenIdleSound" @ getRandom(1,3));
    %obj.AlienQueenIdleLoop = schedule(10000,0,QueenSoundCheck,%obj);
    
}

package AlienQueenPackage {
    function Armor::changeDatablock(%this, %obj, %db) //if this doesn't work, remove %this
    {
        Parent::changeDatablock(%this, %obj, %db); //here too
        if(%db.getName() $= "AlienQueenArmor") schedule(20, 0, QueenSoundCheck, %obj);
    }
    function Armor::setDatablock(%this, %obj, %db) //if this doesn't work, remove %this
    {
        Parent::setDatablock(%this, %obj, %db); //here too
        if(%db.getName() $= "AlienQueenArmor") schedule(20, 0, QueenSoundCheck, %obj);
    }
};
activatePackage(AlienQueenPackage);